//
//  AppDelegate.m
//  Waste
//
//  Created by Brad Goss on 11/05/09.
//  Copyright 2009 GossTech Inc.. All rights reserved.
//

#import "AppDelegate.h"


@implementation AppDelegate

- (void)awakeFromNib {
	[[imageView layer] setDelegate:self];
	
	/* later when we call [[imageView layer] setNeedsDisplay]
		this object AppDelegate will be used to draw the layer
	 */
}

- (IBAction)convert:(id)sender {
	[NSAnimationContext beginGrouping];
	[[NSAnimationContext currentContext] setDuration:3.0f]; // sets the animation duration to 3 seconds
	
	// create a new frame
	NSRect newRect = [imageView frame];
	newRect.origin.x = 200;
	newRect.origin.y = 200;
	newRect.size.width = 100;
	newRect.size.height = 100;
	// use the proxy object to animate the frame to a new location and size
	[[imageView animator] setFrame:newRect];
	
	// end the current animation context
	[NSAnimationContext endGrouping];
	
	// state represents if the image is red or white
	state = !state;
	
	// tell the layer to redraw itself
	[[imageView layer] setNeedsDisplay];
}

// this method is called when [[imageView layer] setNeedsDisplay] is called. Never call it directly
- (void)drawLayer:(CALayer *)thelayer inContext:(CGContextRef)ctx {
	
	// we currently have a Core Graphics Context... Lets use it to setup a NSGraphicsContext for convenience
	NSGraphicsContext *nsGraphicsContext;
	nsGraphicsContext = [NSGraphicsContext graphicsContextWithGraphicsPort:ctx
																   flipped:NO];
	[NSGraphicsContext saveGraphicsState];
	[NSGraphicsContext setCurrentContext:nsGraphicsContext];
	// we have finished setting up the NSGraphicsContext
	
	// draw the new image
	if ( state )
		[[NSImage imageNamed:@"red"] drawInRect:NSRectFromCGRect([thelayer frame]) fromRect:NSZeroRect operation:NSCompositeSourceOver fraction:1.0];
	else
		[[NSImage imageNamed:@"white"] drawInRect:NSRectFromCGRect([thelayer frame]) fromRect:NSZeroRect operation:NSCompositeSourceOver fraction:1.0];
	
	[NSGraphicsContext restoreGraphicsState]; // now restore the graphics context to its original state
}

@end
